<?php

/* plugin.quiz_en.php
English version of QuizBot 1.5 by Reaby

Many thanks for Assembler Maniac for Chatbot which this bot utilizes the main loop for getting chat-text from users.

How it works?
To ask manually question simply type /quiz_ask [question] ? [answer]
To ask question from file type /quiz
To reset points /quiz_reset

for example:
/quiz_ask which color has red car on ? red

answering normally by typing to chat.

*/

Aseco::registerEvent('onStartup', 'quizbot_startup');
Aseco::registerEvent('onChat', 'quizbot_chat');

Aseco::addChatCommand('quiz_points', 'Shows quiz points');
Aseco::addChatCommand('quiz_reset', 'Resets the Quiz');
Aseco::addChatCommand('quiz_ask', 'Ask a question, right answer after questionmark');
Aseco::addChatCommand('quiz', 'Ask a question from file');

class quizbot
   {
   public $Aseco;
   public $points;
   private $rightAnswer;
   public $Question;
   
   function checkChatText(&$command)
      {
      // ignore text that comes from the server
      // also ignore anything that looks like it's a command
      if ( $command[0] == 0 || substr($command[2], 0, 1) == '/' )      // $command[0] is the player id, 0 = server
         {
         return;
         }

     if ( isset($this->rightAnswer)) {
         if ( strtolower($command[2]) == strtolower($this->rightAnswer) )
            {
         $message = "\$0b0 Right answer! \$fff".$this->rightAnswer;
          $this->Aseco->client->query('GetPlayerInfo', $command[1]);
         $info = $this->Aseco->client->getResponse();
         $nick = $info['NickName'];
         $this->points[$command[1]]['NickName'] = $nick;
         $this->points[$command[1]]['Points']++;
            $this->Aseco->client->query("ChatSendServerMessage", $message);
            $this->points();  // show points at successcull answer
      unset($this->rightAnswer);
           return;
            }
         
         }
   
      }  //  checkChatText
   
   function ask_question($command) {
   $pos = strpos($command,"?");
   $this->rightAnswer=trim(str_replace("?","",strstr($command,"?")));
   $this->Question=substr($command,0,$pos);
   $message = "Question: \$fa0".substr($command,0,$pos)."?"; 
    $this->Aseco->client->query("ChatSendServerMessage", $message);
    }
   
   function ask_question_from_file() {
   $questions = file('quiz_questions.txt');
   $Qcount = count($questions);
   $Qdata = trim($questions[rand(0,$Qcount)]);
   $pos = strpos($Qdata,"?");
   $this->rightAnswer=trim(str_replace("?","",strstr($Qdata,"?")));
   $this->Question=substr($Qdata,0,$pos);
   $message = "Question: \$fa0".substr($Qdata,0,$pos)."?"; 
    $this->Aseco->client->query("ChatSendServerMessage", $message);
    }
   
   
   function points() {

   if (count($this->points) >= 1)
   foreach ($this->points as $info) {
   $message .=$info['NickName'].": \$z\$s\$fff".$info['Points']." ";
   }
    $this->Aseco->client->query("ChatSendServerMessage", $message);
    }
}

## End of class

function quizbot_startup()
   {
   global $aseco;
   global $quizbot;

   $quizbot = new quizbot();

   $quizbot->Aseco = $aseco;
   }

function quizbot_chat(&$aseco, &$command)
   {
   global $quizbot;
   $quizbot->checkChatText($command);
   }
   
function chat_quiz_points($aseco, $command) {
   global $quizbot;
    $quizbot->points();
   return;
}  // chat_quiz_points

function chat_quiz_reset($aseco, $command) {
global $quizbot;
$message = "Scores are now reset!";
$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));
unset($quizbot->points);
return;
}

function chat_quiz_ask($aseco, $command) {
global $quizbot;
$quizbot->ask_question($command['params']);
return;
}

function chat_quiz($aseco, $command) {
global $quizbot;
$quizbot->ask_question_from_file();
return;
}

?>
